<html>
<head>
<title>OGRE: Ogre::Plugin Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1Plugin.html">Plugin</a></div>
<h1>Ogre::Plugin Class Reference</h1><!-- doxytag: class="Ogre::Plugin" -->Class defining a generic OGRE plugin.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgrePlugin_8h-source.html">OgrePlugin.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1Plugin-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#02890fc726dd3163721bdbec1c60339a">Plugin</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#8f531cb7678768d34140e1aa15335f57">~Plugin</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#25a8ef68cc19a03260696ce1c3d3d399">getName</a> () const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the name of the plugin.  <a href="#25a8ef68cc19a03260696ce1c3d3d399"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#556fd0c6a5a05cce82dc7df998c99c0f">install</a> ()=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Perform the plugin initial installation sequence.  <a href="#556fd0c6a5a05cce82dc7df998c99c0f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#890da15775afd75c14e81bc6207de81f">initialise</a> ()=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Perform any tasks the plugin needs to perform on full system initialisation.  <a href="#890da15775afd75c14e81bc6207de81f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#17fe6741c49a0fb9153797c70bdb884b">shutdown</a> ()=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Perform any tasks the plugin needs to perform when the system is shut down.  <a href="#17fe6741c49a0fb9153797c70bdb884b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#47748105a90ce86b7e0f99a6910bd31d">uninstall</a> ()=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Perform the final plugin uninstallation sequence.  <a href="#47748105a90ce86b7e0f99a6910bd31d"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Class defining a generic OGRE plugin. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>OGRE is very plugin-oriented and you can customise much of its behaviour by registering new plugins, dynamically if you are using dynamic linking. This class abstracts the generic interface that all plugins must support. Within the implementations of this interface, the plugin must call other OGRE classes in order to register the detailed customisations it is providing, e.g. registering a new <a class="el" href="classOgre_1_1SceneManagerFactory.html" title="Class which will create instances of a given SceneManager.">SceneManagerFactory</a>, a new <a class="el" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject...">MovableObjectFactory</a>, or a new <a class="el" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Plugins can be linked statically or dynamically. If they are linked dynamically (ie the plugin is in a DLL or Shared Object file), then you load the plugin by calling the <a class="el" href="classOgre_1_1Root.html#f0744e85bddb05885a91809bcdf8f864" title="Manually load a Plugin contained in a DLL / DSO.">Root::loadPlugin</a> method (or some other mechanism which leads to that call, e.g. plugins.cfg), passing the name of the DLL. OGRE will then call a global init function on that DLL, and it will be expected to register one or more <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> implementations using <a class="el" href="classOgre_1_1Root.html#5ea47cd9c094644e1abac7607e1922fd" title="Install a new plugin.">Root::installPlugin</a>. The procedure is very similar if you use a static linked plugin, except that you simply instantiate the <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> implementation yourself and pass it to <a class="el" href="classOgre_1_1Root.html#5ea47cd9c094644e1abac7607e1922fd" title="Install a new plugin.">Root::installPlugin</a>. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Lifecycle of a <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> instance is very important. The <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> instance must remain valid until the <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> is uninstalled. Here are the things you must bear in mind: <ul>
<li>
If your plugin is in a DLL: <ul>
<li>
Create the <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> instance and call <a class="el" href="classOgre_1_1Root.html#5ea47cd9c094644e1abac7607e1922fd" title="Install a new plugin.">Root::installPlugin</a> in dllStartPlugin </li>
<li>
Call <a class="el" href="classOgre_1_1Root.html#23417d6cbe7aeeafcc6a1a146a5e7b95" title="Uninstall an existing plugin.">Root::uninstallPlugin</a>, then delete it in dllStopPlugin</li>
</ul>
</li>
<li>
If your plugin is statically linked in your app: <ul>
<li>
Create the <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> anytime you like </li>
<li>
Call <a class="el" href="classOgre_1_1Root.html#5ea47cd9c094644e1abac7607e1922fd" title="Install a new plugin.">Root::installPlugin</a> any time whilst <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a> is valid </li>
<li>
Call <a class="el" href="classOgre_1_1Root.html#23417d6cbe7aeeafcc6a1a146a5e7b95" title="Uninstall an existing plugin.">Root::uninstallPlugin</a> if you like so long as <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a> is valid. However, it will be done for you when <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a> is destroyed, so the <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> instance must still be valid at that point if you haven't manually uninstalled it.</li>
</ul>
</li>
</ul>
The install and unninstall methods will be called when the plugin is installed or uninstalled. The initialise and shutdown will be called when there is a system initialisation or shutdown, e.g. when <a class="el" href="classOgre_1_1Root.html#4ced16ae699e5e6b67a0c95333f21375" title="Initialises the renderer.">Root::initialise</a> or <a class="el" href="classOgre_1_1Root.html#dc677530cc7ef50fbd0e37d75c02e16b" title="Shuts down the system manually.">Root::shutdown</a> are called. </dd></dl>

<p>Definition at line <a class="el" href="OgrePlugin_8h-source.html#l00074">74</a> of file <a class="el" href="OgrePlugin_8h-source.html">OgrePlugin.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="02890fc726dd3163721bdbec1c60339a"></a><!-- doxytag: member="Ogre::Plugin::Plugin" ref="02890fc726dd3163721bdbec1c60339a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::Plugin::Plugin           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgrePlugin_8h-source.html#l00077">77</a> of file <a class="el" href="OgrePlugin_8h-source.html">OgrePlugin.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8f531cb7678768d34140e1aa15335f57"></a><!-- doxytag: member="Ogre::Plugin::~Plugin" ref="8f531cb7678768d34140e1aa15335f57" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::Plugin::~Plugin           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgrePlugin_8h-source.html#l00078">78</a> of file <a class="el" href="OgrePlugin_8h-source.html">OgrePlugin.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="25a8ef68cc19a03260696ce1c3d3d399"></a><!-- doxytag: member="Ogre::Plugin::getName" ref="25a8ef68cc19a03260696ce1c3d3d399" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; Ogre::Plugin::getName           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the name of the plugin. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>An implementation must be supplied for this method to uniquely identify the plugin. </dd></dl>

</div>
</div><p>
<a class="anchor" name="556fd0c6a5a05cce82dc7df998c99c0f"></a><!-- doxytag: member="Ogre::Plugin::install" ref="556fd0c6a5a05cce82dc7df998c99c0f" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::Plugin::install           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Perform the plugin initial installation sequence. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>An implementation must be supplied for this method. It must perform the startup tasks necessary to install any rendersystem customisations or anything else that is not dependent on system initialisation, ie only dependent on the core of <a class="el" href="namespaceOgre.html">Ogre</a>. It must not perform any operations that would create rendersystem-specific objects at this stage, that should be done in <a class="el" href="classOgre_1_1Plugin.html#890da15775afd75c14e81bc6207de81f" title="Perform any tasks the plugin needs to perform on full system initialisation.">initialise()</a>. </dd></dl>

</div>
</div><p>
<a class="anchor" name="890da15775afd75c14e81bc6207de81f"></a><!-- doxytag: member="Ogre::Plugin::initialise" ref="890da15775afd75c14e81bc6207de81f" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::Plugin::initialise           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Perform any tasks the plugin needs to perform on full system initialisation. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>An implementation must be supplied for this method. It is called just after the system is fully initialised (either after <a class="el" href="classOgre_1_1Root.html#4ced16ae699e5e6b67a0c95333f21375" title="Initialises the renderer.">Root::initialise</a> if a window is created then, or after the frist window is created) and therefore all rendersystem functionality is available at this time. You can use this hook to create any resources which are dependent on a rendersystem or have rendersystem-specific implementations. </dd></dl>

</div>
</div><p>
<a class="anchor" name="17fe6741c49a0fb9153797c70bdb884b"></a><!-- doxytag: member="Ogre::Plugin::shutdown" ref="17fe6741c49a0fb9153797c70bdb884b" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::Plugin::shutdown           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Perform any tasks the plugin needs to perform when the system is shut down. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>An implementation must be supplied for this method. This method is called just before key parts of the system are unloaded, such as rendersystems being shut down. You should use this hook to free up resources and decouple custom objects from the OGRE system, whilst all the instances of other plugins (e.g. rendersystems) still exist. </dd></dl>

</div>
</div><p>
<a class="anchor" name="47748105a90ce86b7e0f99a6910bd31d"></a><!-- doxytag: member="Ogre::Plugin::uninstall" ref="47748105a90ce86b7e0f99a6910bd31d" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::Plugin::uninstall           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Perform the final plugin uninstallation sequence. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>An implementation must be supplied for this method. It must perform the cleanup tasks which haven't already been performed in <a class="el" href="classOgre_1_1Plugin.html#17fe6741c49a0fb9153797c70bdb884b" title="Perform any tasks the plugin needs to perform when the system is shut down.">shutdown()</a> (e.g. final deletion of custom instances, if you kept them around incase the system was reinitialised). At this stage you cannot be sure what other plugins are still loaded or active. It must therefore not perform any operations that would reference any rendersystem-specific objects - those should have been sorted out in the 'shutdown' method. </dd></dl>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgrePlugin_8h-source.html">OgrePlugin.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:51:49 2008
</p>
</body>
</html>
